import { http } from "msw";
import { AppHarness } from "../../../mocks/AppHarness";
import { CreateIOCView } from "../../../views/IOC/CreateIOCView";
import { handlers } from "../../../mocks/handlers";
import { userImpersonatorArgs } from "../../utils/common-args";
import general_exception from "../../../mocks/fixtures/GeneralException.json";

export default {
  title: "Views/IOC/CreateIOCView"
};

const Template = (args) => (
  <AppHarness
    useTestUser
    {...args}
  >
    <CreateIOCView />
  </AppHarness>
);

export const Default = (args) => <Template {...args} />;
Default.args = {
  ...userImpersonatorArgs
};

export const CreateLoading = (args) => <Template {...args} />;
CreateLoading.args = {
  ...Default.args
};
CreateLoading.parameters = {
  msw: {
    handlers: [
      http.post("*/iocs", (req, res, ctx) => res(ctx.delay("infinite"))),
      ...handlers
    ]
  }
};

export const CreateWithError = (args) => <Template {...args} />;
CreateWithError.args = {
  ...Default.args
};
CreateWithError.parameters = {
  msw: {
    handlers: [
      http.post("*/iocs", (req, res, ctx) =>
        res(ctx.status(400), ctx.json(general_exception))
      ),
      ...handlers
    ]
  }
};
